unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_YMTRKList, U_YMTFHSQList, U_YMTFHDataList, U_YMTJGWCList,
  U_YMTStockList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := '高权限';
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;
  DName := 'ADMIN';
  DCode := 'ADMIN';

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;

   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  if Trim(DataBaseStr) = '' then
  begin
    server := '106.14.113.234,7781';
    dtbase := 'yunxiangdata';
    user := 'sa';
    pswd := 'rightsoft@123';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    111:  //回仓登记
      begin
        if frmYMTRKList = nil then
        begin
          frmYMTRKList := TfrmYMTRKList.Create(application.MainForm);
          with frmYMTRKList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYMTRKList.BringToFront;
       //句柄
        mnewHandle := frmYMTRKList.Handle;
      end;

    112:  //加工完成回仓数据
      begin
        if frmYMTJGWCList = nil then
        begin
          frmYMTJGWCList := TfrmYMTJGWCList.Create(application.MainForm);
          with frmYMTJGWCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYMTJGWCList.BringToFront;
       //句柄
        mnewHandle := frmYMTJGWCList.Handle;
      end;

    113:  //库存数据
      begin
        if frmStockList = nil then
        begin
          frmStockList := TfrmStockList.Create(application.MainForm);
          with frmStockList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmStockList.BringToFront;
       //句柄
        mnewHandle := frmStockList.Handle;
      end;

//    211:  //发货申请
//      begin
//        if frmYMTFHSQList = nil then
//        begin
//          frmYMTFHSQList := TfrmYMTFHSQList.Create(application.MainForm);
//          with frmYMTFHSQList do
//          begin
//            caption := Trim(Title);
//            FormStyle := mstyle;
//            windowState := mstate;
//            BorderStyle := mborderstyle;
//           //show;
//          end;
//        end
//        else
//          frmYMTFHSQList.BringToFront;
//       //句柄
//        mnewHandle := frmYMTFHSQList.Handle;
//      end;
      211:  //销售发货申请
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '销售发货申请' then
          begin
            BringWindowToTop(frmYMTFHSQList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmYMTFHSQList := TfrmYMTFHSQList.Create(application.MainForm);
          with frmYMTFHSQList do
          begin
            Title := '销售发货申请';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYMTFHSQList.BringToFront;
       //句柄
        mnewHandle := frmYMTFHSQList.Handle;
      end;
    212:  //发货数据
      begin
        if frmYMTFHDataList = nil then
        begin
          frmYMTFHDataList := TfrmYMTFHDataList.Create(application.MainForm);
          with frmYMTFHDataList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYMTFHDataList.BringToFront;
       //句柄
        mnewHandle := frmYMTFHDataList.Handle;
      end;
    213:  //加工发货登记
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '加工发货登记' then
          begin
            BringWindowToTop(frmYMTFHSQList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmYMTFHSQList := TfrmYMTFHSQList.Create(application.MainForm);
          with frmYMTFHSQList do
          begin
            Title := '加工发货登记';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYMTFHSQList.BringToFront;
       //句柄
        mnewHandle := frmYMTFHSQList.Handle;
      end;
  end;

  Result := mnewHandle;
end;


//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_YXYMT) then
    DataLink_YXYMT := TDataLink_YXYMT.Create(Application);
  try
    with DataLink_YXYMT.ADOLink do
    begin
      if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_YXYMT.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

